// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders, HttpQuery } from '../runtime';
import type {
    NeurisSearchResult,
} from '../models';

export interface DoNeuRisSucheRequest {
    suchString: string;
}

export interface GetBestandsrechtByEliRequest {
    eli: string;
}

/**
 * no description
 */
export class NeuRisControllerApi extends BaseAPI {

    /**
     * Liefert eine Liste der Bestandsrechte aus NeuRIS.
     * Lädt Bestandsrechte gemäß des übergebenen Suchbegriffs.
     */
    doNeuRisSuche({ suchString }: DoNeuRisSucheRequest): Observable<NeurisSearchResult>
    doNeuRisSuche({ suchString }: DoNeuRisSucheRequest, opts?: OperationOpts): Observable<AjaxResponse<NeurisSearchResult>>
    doNeuRisSuche({ suchString }: DoNeuRisSucheRequest, opts?: OperationOpts): Observable<NeurisSearchResult | AjaxResponse<NeurisSearchResult>> {
        throwIfNullOrUndefined(suchString, 'suchString', 'doNeuRisSuche');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<NeurisSearchResult>({
            url: '/neuris/suche/{suchString}'.replace('{suchString}', encodeURI(suchString)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert ein Bestandsrecht (im XML-Format) aus NeuRIS anhand einer ELI (Beispiel: bgbl-1/2023/s12).
     * Lädt das Bestandsrecht als XML durch die übergebene ELI (Beispiel: bgbl-1/2023/s12).
     */
    getBestandsrechtByEli({ eli }: GetBestandsrechtByEliRequest): Observable<string>
    getBestandsrechtByEli({ eli }: GetBestandsrechtByEliRequest, opts?: OperationOpts): Observable<AjaxResponse<string>>
    getBestandsrechtByEli({ eli }: GetBestandsrechtByEliRequest, opts?: OperationOpts): Observable<string | AjaxResponse<string>> {
        throwIfNullOrUndefined(eli, 'eli', 'getBestandsrechtByEli');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = { // required parameters are used directly since they are already checked by throwIfNullOrUndefined
            'eli': eli,
        };

        return this.request<string>({
            url: '/neuris/norm',
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

}
